/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: uart_pl011.c 324 2007-07-17 06:00:17Z hiro $
 */

/*
 *   PL011 ʰSIOɥ饤
 */

#include <sil.h>
#include "target_syssvc.h"
#include "uart_pl011.h"

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
    void  *dr;
    void  *sr_cr;
    void  *fr;
    void  *lpr;
    void  *ibrd;
    void  *fbrd;
    void  *lcr_h;
    void  *cr;
    void  *ifls;
    void  *imsc;
    void  *ris;
    void  *mis;
    void  *icr;
    void  *dmacr;
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block {
    const SIOPINIB  *siopinib;  /* ꥢI/OݡȽ֥å */
    intptr_t  exinf;            /* ĥ */
    bool_t    openflag;           /* ץѤߥե饰 */
    bool_t    sendflag;           /* ߥ֥͡ե饰 */
    bool_t    getready;           /* ʸ */
    bool_t    putready;           /* ʸǤ */
};

/*
 *  ꥢI/OݡȽ֥å
 */

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
	{(void *)(UART_BASE_REG + UART_PL011_DR),
	(void *)(UART_BASE_REG + UART_PL011_SR_CR),
	(void *)(UART_BASE_REG + UART_PL011_FR),
	(void *)(UART_BASE_REG + UART_PL011_LPR),
	(void *)(UART_BASE_REG + UART_PL011_IBRD),
	(void *)(UART_BASE_REG + UART_PL011_FBRD),
	(void *)(UART_BASE_REG + UART_PL011_LCR_H),
	(void *)(UART_BASE_REG + UART_PL011_CR),
	(void *)(UART_BASE_REG + UART_PL011_IFLS),
	(void *)(UART_BASE_REG + UART_PL011_IMSC),
	(void *)(UART_BASE_REG + UART_PL011_RIS),
	(void *)(UART_BASE_REG + UART_PL011_MIS),
	(void *)(UART_BASE_REG + UART_PL011_ICR),
	(void *)(UART_BASE_REG + UART_PL011_DMACR)
    }
};


/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)	((uint_t)((siopid) - 1))
#define get_siopcb(siopid)	(&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 *  ʸǤ뤫
 */
Inline bool_t
uart_pl011_getready(SIOPCB *p_siopcb)
{
    return(((sil_rew_mem((void *)(p_siopcb->siopinib->fr)) & UFR_RXFE) == 0));    
}

/*
 *  ʸǤ뤫
 */
Inline bool_t
uart_pl011_putready(SIOPCB *p_siopcb)
{
    return((sil_rew_mem((void *)(p_siopcb->siopinib->fr)) & UFR_TXFF) == 0);
}

/*
 *  ʸμФ
 */
Inline char_t
uart_pl011_getchar(SIOPCB *p_siopcb)
{
    return(sil_rew_mem((void *)(p_siopcb->siopinib->dr)));
}

/*
 *  ʸν
 */
Inline void
uart_pl011_putchar(SIOPCB *p_siopcb, char_t c)
{
    sil_wrw_mem((void *)(p_siopcb->siopinib->dr), c);
}

/*
 *  ߵ
 */
Inline void
uart_pl011_enable_send(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void *)(p_siopcb->siopinib->imsc),
        (sil_rew_mem((void *)(p_siopcb->siopinib->imsc)) | UART_IMSC_TXIM));
}

/*
 *  ߶ػ
 */
Inline void
uart_pl011_disable_send(SIOPCB *p_siopcb)
{
     sil_wrw_mem((void *)(p_siopcb->siopinib->imsc),
        (sil_rew_mem((void *)(p_siopcb->siopinib->imsc)) & ~UART_IMSC_TXIM));
}


/*
 *  ߵ
 */
Inline void
uart_pl011_enable_rcv(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void *)(p_siopcb->siopinib->imsc),
        (sil_rew_mem((void *)(p_siopcb->siopinib->imsc)) | UART_IMSC_RXIM));
}

/*
 *  ߶ػ
 */
Inline void
uart_pl011_disable_rcv(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void *)(p_siopcb->siopinib->imsc),
        (sil_rew_mem((void *)(p_siopcb->siopinib->imsc)) & ~UART_IMSC_RXIM));
}

/*
 *  SIOɥ饤Фν
 */
void
uart_pl011_initialize(void)
{
	SIOPCB	*p_siopcb;
	uint_t	i;

	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
    for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
        p_siopcb->siopinib = &(siopinib_table[i]);
        p_siopcb->openflag = false;
        p_siopcb->sendflag = false;
    }
}

/*
 *  ץ󤷤ƤݡȤ뤫
 */
bool_t
uart_pl011_openflag(void)
{

#if TNUM_SIOP == 1         
    return(siopcb_table[0].openflag);
#else /* TNUM_SIOP == 1 */
	return(siopcb_table[0].openflag || siopcb_table[1].openflag);
#endif    
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
uart_pl011_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB          *p_siopcb;
    const SIOPINIB  *p_siopinib;

    p_siopcb = get_siopcb(siopid);
    p_siopinib = p_siopcb->siopinib;

	/* setup baud rate divisor */
	sil_wrw_mem((void *)(p_siopinib->ibrd), 0x068);
	sil_wrw_mem((void *)(p_siopinib->fbrd), 0x00B);

	/* refer to the TRM for details */
	sil_wrw_mem((void *)(p_siopinib->cr), 0x301);
	sil_wrw_mem((void *)(p_siopinib->lcr_h), 0x060);
	sil_wrw_mem((void *)(p_siopinib->ifls), 0x000);

	/* Mask all interrupt */
	sil_wrw_mem((void *)(p_siopinib->imsc), 0);

    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);   
}

/*
 *  ꥢI/OݡȤΥ
 */
void
uart_pl011_cls_por(SIOPCB *p_siopcb)
{
//    sil_wrw_mem((void *)(p_siopcb->siopinib->cr),
//        (sil_rew_mem((void *)(p_siopcb->siopinib->cr)) & ~UCR_UARTEN)); /* Disable Interrupt */
    
    p_siopcb->openflag = false;
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
uart_pl011_snd_chr(SIOPCB *p_siopcb, char_t c)
{
    if (uart_pl011_putready(p_siopcb)){
        uart_pl011_putchar(p_siopcb, c);
        return(true);
    }
    return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
uart_pl011_rcv_chr(SIOPCB *p_siopcb)
{
	if (uart_pl011_getready(p_siopcb)) {
		return((int_t)(uint8_t) uart_pl011_getchar(p_siopcb));
	}
	return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
uart_pl011_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        uart_pl011_enable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        uart_pl011_enable_rcv(p_siopcb);
        break;
    }
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
uart_pl011_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        uart_pl011_disable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        uart_pl011_disable_rcv(p_siopcb);
        break;
    }
}

/*
 *  ꥢI/OݡȤФ߽
 */
static void
uart_pl011_isr_siop(SIOPCB *p_siopcb)
{
    if (uart_pl011_getready(p_siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        uart_pl011_irdy_rcv(p_siopcb->exinf);
    }
    if (uart_pl011_putready(p_siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        uart_pl011_irdy_snd(p_siopcb->exinf);
    }
}

/*
 *  SIOγߥӥ롼
 */
void
uart_pl011_isr0()
{
    uart_pl011_isr_siop(&(siopcb_table[0]));
}
